// CDPlayer.cpp: implementation of the CDPlayer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CDPlayer.h"
#include "libcda.h"


CDPlayer  cdplay;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDPlayer::CDPlayer()
{
	m_inited = !cd_init();
	m_use = true;
}

CDPlayer::~CDPlayer()
{
	if (m_inited) cd_exit();
}

void CDPlayer::Play()
{
	if (!m_use) return;
	if (!m_inited) return;

	if (cd_is_paused()) cd_resume();
	else 
		if (!cd_current_track()) {
			NewSong();
		}
}

void CDPlayer::Pause()
{
	if (!m_inited) return;
	if (!m_use) return;
	cd_pause();
}

void CDPlayer::Close()
{
	if (!m_inited) return;
	if (!m_use) return;
	cd_exit();
	m_inited = false;
}


void CDPlayer::NewSong()
{
	if (!m_use) return;
	if (!m_inited) return;

	int a,b;
	cd_get_tracks(&a, &b);
	cd_play(rand()%(a-b+1)+a);
}
