// GFile.cpp: implementation of the GFile class.
//
//////////////////////////////////////////////////////////////////////

#include "stdh.h"
#include "GFile.h"
#include "GMap.h"

/*////////////////////////////////////////////////////////////////////////////////
  Konstruktor
*/
GFile::GFile()
{
	m_fh = -1;
}

/*////////////////////////////////////////////////////////////////////////////////
  Destruktok
*/
GFile::~GFile()
{
	if (m_fh != -1) CloseFile();
}

/*////////////////////////////////////////////////////////////////////////////////
  Otevre a cte soubor s trati
  filename : jmeno souboru
*/
bool GFile::OpenFile(char *filename)
{
	CloseFile(); // pro jistotu
	if ((m_fh = _open( filename, _O_BINARY | _O_RDONLY )) == -1 )
		return false;    // nepodarilo se otevrit soubor
	
	_read(m_fh, &m_header, sizeof(m_header)); // nacteni hlavicky
	if (m_header.sign != FILE_SIGN) {
		CloseFile();
		return false;
	}

	return true;
}

/*////////////////////////////////////////////////////////////////////////////////
  Zavre soubor
*/
void GFile::CloseFile()
{
	if (m_fh != -1) _close( m_fh );
	m_fh = 0;
}

/*////////////////////////////////////////////////////////////////////////////////
  Nacte data ze souboru 
  map  :  objekt may, kam se ma soubor nacist
*/
bool GFile::LoadData(GMap *map)
{
	int i;
	// init
	if (m_fh == -1) return false;

	//TODO: testovat navratove hodnoty pri nacitani
	// hopnem na zacetek souboru
	_lseek(m_fh, 0, SEEK_SET);

	// cteni hlavicky
	_read(m_fh, &m_header, sizeof(m_header)); // nacteni hlavicky
	if (m_header.sign != FILE_SIGN) return false;

	map->Reset(m_header.x, m_header.y);

	
	// cteni objektu
	st_GFile_Object ob;
	for (i = 0; i < m_header.objects; i++) {
		_read(m_fh, &ob, sizeof(ob)); // nacteni hlavicky
	}

	map->InitDone();
	return true;
}
