// GMenu.cpp: implementation of the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenu.h"
#include "GMenuSet.h"
#include "GMenuBackFading.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define MAX_COM_SPEEDS 4

const DWORD COMSPEED[MAX_COM_SPEEDS] = {
	56000, 57600, 115200, 128000
};

GMenu::GMenu()
{
	m_back     = NULL;
	m_item     = 0;
	m_maxplay  = MAX_PLAYERS;
}

GMenu::~GMenu()
{
}

bool GMenu::Run(GRun *run)
{
   clear_keybuf();
	m_run = run;
	m_konec = false;
	while(!m_konec) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		Draw();
		if (ProccesKeys()) {
			hscreen.FadeDown();
			return true;
		}
		while (tmr != 0); // cekame, za dobehe timer
	}

	hscreen.FadeDown();
	return false;
}

void GMenu::Draw()
{

	m_back->Acquire();

	m_back->Clear();

	// menu
	char s[80];
	sprintf(s, "SERIOVE COM %d",ini.com+1);
	DrawMyFontCenter(m_back->m_back, 320,  70, Col(0), s);
	DrawMyFontCenter(m_back->m_back, 320, 110, Col(1), "IPX SPOJENI");
	DrawMyFontCenter(m_back->m_back, 320, 150, Col(2), "TCP-IP SPOJENI");
	sprintf(s, "< PROTI %d POCITACUM >", m_maxplay-1);
	DrawMyFontCenter(m_back->m_back, 320, 190, Col(3), s);
	DrawMyFontCenter(m_back->m_back, 320, 230, Col(4), "DEMO");
	DrawMyFontCenter(m_back->m_back, 320, 270, Col(5), "NASTAVENI");
	DrawMyFontCenter(m_back->m_back, 320, 310, Col(6), "KONEC");

	// okoli
	textprintf_centre(m_back->m_back, font, 320,  50, makecol(255,10,10), "KULIC - 0.20");
	textprintf_centre(m_back->m_back, font, 320, 400, makecol(10,10,255), "HIPPO GAMES - 2000");
	textprintf_centre(m_back->m_back, font, 320, 430, makecol(10,10,255), "navrhy a pripominky : lidicky.98@gyarab.cz");
	textprintf(m_back->m_back, font, 10, 10, makecol(10,10,255), "Bernard Lidicky & Zdenek Boswart");

	m_back->Release();

	m_back->Flip();
}

bool GMenu::ProccesKeys()
{
	int  c, c2;
	m_buf[0] = '\0';
	while(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_konec;
			break;
		case KEY_DOWN :
			if(++m_item > it_konec) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_single) 
				if(--m_maxplay < 1) m_maxplay = 1;
			break;
		case KEY_RIGHT :
			if (m_item == it_single) 
				if(++m_maxplay > MAX_PLAYERS) m_maxplay = MAX_PLAYERS;
			break;
		case KEY_ENTER :
			if (m_item == it_com)
				if (net->ConnectSERIAL(ini.com+1, COMSPEED[ini.com_speed])) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "COM spojeni se nezdarilo");

			if (m_item == it_ipx)
				if (net->ConnectIPX()) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "IPX spojeni se nezdarilo");

			if (m_item == it_tcpip)
				if (net->ConnectTCPIP(ini.ip)) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "TCP/IP spojeni se nepodarilo");

			if (m_item == it_single) {
				m_run->m_net.m_connected = false;
				m_run->InitSingle(m_maxplay);
				return true;
			}

			if (m_item == it_demo) {
				hscreen.FadeDown();
				m_run->Demo();
			}

			if (m_item == it_konec) m_konec = true;

			if (m_item == it_nastaveni) {
				m_back->FadeOut();
				GMenuSet mn;
				mn.Run(m_run, m_back);
			}

			break;
		}
	}

	if(m_buf[0] != '\0') 
		allegro_message(m_buf);

	return false;
}

int GMenu::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}

void GMenu::LoadGFX(GRun *run)
{
	draw_loading();
	Destroy(NULL);

	if (run->m_effects)
		m_back = new GMenuBackFading;
	else
		m_back = new GMenuBack;

	m_back->LoadGFX();

}

void GMenu::Destroy(GRun *run)
{

	if (m_back != NULL) {
		m_back->Destroy();
		delete m_back;
		m_back = NULL;
	}

	ini.pocitacu = m_maxplay;
}


