// GMenu.cpp: implementation of the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
BITMAP *b_menu;

#define MAX_COM_SPEEDS 4

const DWORD COMSPEED[MAX_COM_SPEEDS] = {
	56000, 57600, 115200, 128000
};

GMenu::GMenu()
{
	b_menu  = NULL;
	m_angle = 0;
	m_item     = 0;
	m_postava  = 0;
	m_maxplay  = MAX_PLAYERS;

	m_map = 2;
}

GMenu::~GMenu()
{
}

bool GMenu::Run(GRun *run)
{
	run->InitDemo();

   clear_keybuf();
	m_konec = false;
	while(!m_konec) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		run->MoveDemo();
		Draw(run->m_sold[0].m_name);
		if (ProccesKeys(run)) return true;
		while (tmr != 0); // cekame, za dobehe timer
	}
	return false;
}

void GMenu::Draw(char *name)
{
//	draw_sprite(hscreen.m_back, b_menu, 0, 0);

	// menu
	if(++m_angle > 255) m_angle  = 0;
		rotate_sprite(hscreen.m_back, b_solds[Sparams[m_postava].bindex], 300, 70, itofix(m_angle));

	textprintf_centre(hscreen.m_back, font, 320, 100, Col(0), "<- Jmeno/Postava : %s ->",name);
	textprintf_centre(hscreen.m_back, font, 320, 130, Col(1), "Seriove spojeni po com %d",ini.com+1);
	textprintf_centre(hscreen.m_back, font, 320, 160, Col(2), "IPX spojeni");
	textprintf_centre(hscreen.m_back, font, 320, 190, Col(3), "TCP/IP spojeni");
	textprintf_centre(hscreen.m_back, font, 320, 220, Col(4), "<- Proti %d pocitacum ->", m_maxplay-1);
	textprintf_centre(hscreen.m_back, font, 320, 250, Col(5), "<- Mapa :  %d ->", m_mapa);
	textprintf_centre(hscreen.m_back, font, 320, 280, Col(6), "Konec");

	// okoli
//	textprintf(hscreen.m_back, font, 10, 450, makecol(150,150,150), "Ovladani : sipky(pohyb), RShift(beh), Enter(navrat po smrti), RAlt(ukrok),");
//	textprintf(hscreen.m_back, font, 10, 470, makecol(150,150,150), "           RCtrl(strelba),  F1(opraveni grafiky pri blikani)");
	textprintf_centre(hscreen.m_back, font, 320,  50, makecol(255,10,10), "KULIC - 0.03");
	textprintf_centre(hscreen.m_back, font, 320, 400, makecol(10,10,255), "HIPPO GAMES - 2000");
	textprintf_centre(hscreen.m_back, font, 320, 430, makecol(10,10,255), "navrhy a pripominky : lidicky.98@gyarab.cz");
	textprintf(hscreen.m_back, font, 10, 10, makecol(10,10,255), "Bernard Lidicky & Zdenek Boswart");
	hscreen.Flip();
}

bool GMenu::ProccesKeys(GRun *run)
{
	int  c, c2;
	m_buf[0] = '\0';
	if(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_konec;
			break;
		case KEY_DOWN :
			if(++m_item > it_konec) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_single) 
				if(--m_maxplay < 1) m_maxplay = 1;
			if (m_item == it_jmeno) 
				if(--m_postava < 0) m_postava = MAX_SOLDIERS-1;
			if (m_item == it_mapa) 
				if(--m_mapa < 1) m_mapa = 1;
			break;
		case KEY_RIGHT :
			if (m_item == it_single) 
				if(++m_maxplay > MAX_PLAYERS) m_maxplay = MAX_PLAYERS;
			if (m_item == it_jmeno) 
				if(++m_postava > MAX_SOLDIERS) m_postava = 0;
			if (m_item == it_mapa) 
				if(++m_mapa > m_map) m_mapa = m_map;
			break;
		case KEY_F3 :
			run->m_map.ClearGround();
			break;
		case KEY_ENTER :
			if (m_item == it_com)
				if (net->ConnectSERIAL(ini.com+1, COMSPEED[ini.com_speed])) {
					run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "COM spojeni se nezdarilo");

			if (m_item == it_ipx)
				if (net->ConnectIPX()) {
					run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "IPX spojeni se nezdarilo");

			if (m_item == it_tcpip)
				if (net->ConnectTCPIP(ini.ip)) {
					run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "TCP/IP spojeni se nepodarilo");

			if (m_item == it_single) {
				run->m_net.m_connected = false;
				run->InitSingle(m_maxplay);
				return true;
			}

			if (m_item == it_konec) m_konec = true;
			break;
		case KEY_BACKSPACE :
		case KEY_DEL :
			if (run->m_sold[0].m_name[0] != '\0')
				run->m_sold[0].m_name[strlen(run->m_sold[0].m_name)-1] = '\0';
			break;
		default :
			c = c2 & 0xff;
			if (islower(c)) c = _toupper(c); // aby se nepsalo malejma pismenkama
			int len = strlen(	run->m_sold[0].m_name);
			if (len < 50) {
				run->m_sold[0].m_name[len] = c;
				run->m_sold[0].m_name[len+1] = '\0';
			}
		}
	}

	if(m_buf[0] != '\0') 
		allegro_message(m_buf);

	return false;
}

int GMenu::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}

void GMenu::LoadGFX(GRun *run)
{
	Destroy(NULL);
	PALETTE pal;
	b_menu = load_bitmap("menu.bmp",pal);
	if (b_menu == NULL) {
		b_menu = create_bitmap(640, 480);
		clear(b_menu);
	}

	// nacteni nastaveni
	strcpy(run->m_sold[0].m_name, ini.jmeno);
	m_maxplay = ini.pocitacu;
	m_postava = ini.postava;
	m_mapa    = ini.mapa;
}

void GMenu::Destroy(GRun *run)
{
	if (b_menu != NULL) {
		destroy_bitmap(b_menu);
		b_menu = NULL;
	}

	if (run == NULL) return;

	// ulozeni nastaveni
	int infile;
	strcpy(ini.jmeno, run->m_sold[0].m_name);
	ini.pocitacu = m_maxplay;
	ini.postava  = m_postava;
	ini.mapa     = m_mapa;
	if ((infile = _open( INIFILE, _O_BINARY | _O_WRONLY )) == -1 ) 
		return;    // nepodarilo se otevrit soubor

	_write(infile, &ini, sizeof(ini)); // nacteni hlavicky

	_close(infile);

}
