// GMenu.cpp: implementation of the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenu.h"
#include "GMenuSet.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
BITMAP *b_menu;

#define MAX_COM_SPEEDS 4

const DWORD COMSPEED[MAX_COM_SPEEDS] = {
	56000, 57600, 115200, 128000
};

GMenu::GMenu()
{
	b_menu  = NULL;
	m_item     = 0;
	m_maxplay  = MAX_PLAYERS;
}

GMenu::~GMenu()
{
}

bool GMenu::Run(GRun *run)
{
   clear_keybuf();
	m_run = run;
	m_konec = false;
	while(!m_konec) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		Draw();
		if (ProccesKeys()) {
			hscreen.FadeDown();
			return true;
		}
		while (tmr != 0); // cekame, za dobehe timer
	}

	hscreen.FadeDown();
	return false;
}

void GMenu::Draw()
{
	hscreen.AcquireBack();
	draw_sprite(hscreen.m_back, b_menu, 0, 0);

	// menu
	textprintf_centre(hscreen.m_back, font, 320, 100, Col(0), "Seriove spojeni po com %d",ini.com+1);
	textprintf_centre(hscreen.m_back, font, 320, 130, Col(1), "IPX spojeni");
	textprintf_centre(hscreen.m_back, font, 320, 160, Col(2), "TCP/IP spojeni");
	textprintf_centre(hscreen.m_back, font, 320, 190, Col(3), "<- Proti %d pocitacum ->", m_maxplay-1);
	textprintf_centre(hscreen.m_back, font, 320, 220, Col(4), "Demo");
	textprintf_centre(hscreen.m_back, font, 320, 250, Col(5), "Nastaveni");
	textprintf_centre(hscreen.m_back, font, 320, 280, Col(6), "Konec");

	// okoli
	textprintf_centre(hscreen.m_back, font, 320,  50, makecol(255,10,10), "KULIC - 0.20");
	textprintf_centre(hscreen.m_back, font, 320, 400, makecol(10,10,255), "HIPPO GAMES - 2000");
	textprintf_centre(hscreen.m_back, font, 320, 430, makecol(10,10,255), "navrhy a pripominky : lidicky.98@gyarab.cz");
	textprintf(hscreen.m_back, font, 10, 10, makecol(10,10,255), "Bernard Lidicky & Zdenek Boswart");
	hscreen.ReleaseBack();

	hscreen.Flip();
}

bool GMenu::ProccesKeys()
{
	int  c, c2;
	m_buf[0] = '\0';
	while(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_konec;
			break;
		case KEY_DOWN :
			if(++m_item > it_konec) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_single) 
				if(--m_maxplay < 1) m_maxplay = 1;
			break;
		case KEY_RIGHT :
			if (m_item == it_single) 
				if(++m_maxplay > MAX_PLAYERS) m_maxplay = MAX_PLAYERS;
			break;
		case KEY_ENTER :
			if (m_item == it_com)
				if (net->ConnectSERIAL(ini.com+1, COMSPEED[ini.com_speed])) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "COM spojeni se nezdarilo");

			if (m_item == it_ipx)
				if (net->ConnectIPX()) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "IPX spojeni se nezdarilo");

			if (m_item == it_tcpip)
				if (net->ConnectTCPIP(ini.ip)) {
					m_run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "TCP/IP spojeni se nepodarilo");

			if (m_item == it_single) {
				m_run->m_net.m_connected = false;
				m_run->InitSingle(m_maxplay);
				return true;
			}

			if (m_item == it_demo) {
				hscreen.FadeDown();
				m_run->Demo();
			}

			if (m_item == it_konec) m_konec = true;

			if (m_item == it_nastaveni) {
				hscreen.FadeDown();
				GMenuSet mn;
				mn.Run(m_run);
			}

			break;
		}
	}

	if(m_buf[0] != '\0') 
		allegro_message(m_buf);

	return false;
}

int GMenu::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}

void GMenu::LoadGFX(GRun *run)
{
	draw_loading();
	Destroy(NULL);

//	b_menu = hload_bitmap("menu.bmp");
	b_menu = hload_bitmap("gfx\\menu\\menu.jpg");
	if (b_menu == NULL) {
		b_menu = create_bitmap(640, 480);
		clear(b_menu);
	}

}

void GMenu::Destroy(GRun *run)
{
	if (b_menu != NULL) {
		destroy_bitmap(b_menu);
		b_menu = NULL;
	}

	if (run == NULL) return;

	ini.pocitacu = m_maxplay;
}


