// GMenu.cpp: implementation of the GMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define MAX_COM_SPEEDS 4

const DWORD COMSPEED[MAX_COM_SPEEDS] = {
	56000, 57600, 115200, 128000
};

GMenu::GMenu()
{

}

GMenu::~GMenu()
{

}

bool GMenu::Run(GRun *run)
{
   clear_keybuf();
	m_konec = false;
	m_item     = 0;
	m_comID    = 1;
	m_comSpeed = 1;
	m_maxplay  = MAX_PLAYERS;
	while(!m_konec) {
		Draw(run->m_sold[0].m_name);
		if (ProccesKeys(run)) return true;
	}
	return false;
}

void GMenu::Draw(char *name)
{
	// menu
	textprintf_centre(hscreen.m_back, font, 320, 100, Col(0), "Seriove spojeni po com %d",m_comID);
	textprintf_centre(hscreen.m_back, font, 320, 130, Col(1), "Prenos %d b/s",COMSPEED[m_comSpeed]);
	textprintf_centre(hscreen.m_back, font, 320, 160, Col(2), "IPX spojeni");
	textprintf_centre(hscreen.m_back, font, 320, 190, Col(3), "Proti pocitaci");
	textprintf_centre(hscreen.m_back, font, 320, 220, Col(4), "Max %d hracu", m_maxplay);
	textprintf_centre(hscreen.m_back, font, 320, 250, Col(5), "Konec");
	textprintf_centre(hscreen.m_back, font, 320, 280, Col(0), name);

	// okoli
	textprintf(hscreen.m_back, font, 10, 450, makecol(150,150,150), "Ovladani : sipky(pohyb), RShift(beh), Enter(navrat po smrti), RAlt(ukrok),");
	textprintf(hscreen.m_back, font, 10, 470, makecol(150,150,150), "           RCtrl(strelba),  F1(opraveni grafiky pri blikani)");
	textprintf_centre(hscreen.m_back, font, 320,  50, makecol(255,10,10), "KULIC - 0.02");
	textprintf_centre(hscreen.m_back, font, 320, 300, makecol(10,10,255), "HIPPO GAMES - 2000");
	textprintf_centre(hscreen.m_back, font, 320, 350, makecol(10,10,255), "navrhy a pripominky : lidicky.98@gyarab.cz");
	textprintf(hscreen.m_back, font, 10, 10, makecol(10,10,255), "Bernard Lidicky & Zdenek Boswart");
	hscreen.Flip();
}

bool GMenu::Connect()
{
	/*	if (!net->ConnectIPX()) {
		allegro_message("Nepodarilo se spojit IPX"); // SMULA !!!!
		return 2;
	}*/
	if (!net->ConnectSERIAL(2, 57600)) {
//		allegro_message("chyba SERIAL"); // SMULA !!!!
		return false;
	}
	return false;
}

bool GMenu::ProccesKeys(GRun *run)
{
	int  c, c2;
	if(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_konec;
			break;
		case KEY_DOWN :
			if(++m_item > it_konec) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_com) 
				if(--m_comID < 1) m_comID = 1;
			if (m_item == it_comspeed) 
				if(--m_comSpeed < 0) m_comSpeed = 0;
			if (m_item == it_maxplay) 
				if(--m_maxplay < 1) m_maxplay = 1;
			break;
		case KEY_RIGHT :
			if (m_item == it_com) 
				if(++m_comID > 4) m_comID = 4;
			if (m_item == it_comspeed) 
				if(++m_comSpeed > MAX_COM_SPEEDS-1) m_comSpeed = MAX_COM_SPEEDS-1;
			if (m_item == it_maxplay) 
				if(++m_maxplay > MAX_PLAYERS) m_maxplay = MAX_PLAYERS;
			break;
		case KEY_ENTER :
			if (m_item == it_com)
				if (net->ConnectSERIAL(m_comID, COMSPEED[m_comSpeed])) {
					run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
				else strcpy(m_buf, "COM spojeni se nezdarilo :( ");

			if (m_item == it_ipx)
				if (net->ConnectIPX()) {
					run->m_net.m_connected = true; // podarilo se navazat spojeni
					return true;
				}
			else strcpy(m_buf, "IPX spojeni se nezdarilo :( ");

			if (m_item == it_single) {
				run->m_net.m_connected = false;
				run->InitSingle(m_maxplay);
				return true;
			}

			if (m_item == it_konec) m_konec = true;
			break;
		case KEY_BACKSPACE :
		case KEY_DEL :
			if (run->m_sold[0].m_name[0] != '\0')
				run->m_sold[0].m_name[strlen(run->m_sold[0].m_name)-1] = '\0';
			break;
		default :
			c = c2 & 0xff;
			char ch = c;
			int len = strlen(	run->m_sold[0].m_name);
			if (len < 50) {
				run->m_sold[0].m_name[len] = c;
				run->m_sold[0].m_name[len+1] = '\0';
			}
		}
	}
	return false;
}

int GMenu::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}
