// GMenuSet.cpp: implementation of the GMenuSet class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GMenuSet.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GMenuSet::GMenuSet()
{
	m_angle = 0;
	m_item     = 0;
}

GMenuSet::~GMenuSet()
{

}

void GMenuSet::Run(GRun *run)
{
	m_run = run;
	if (!LoadGfx()) return;
   clear_keybuf();
	for(;;) {
		tmr  = 5; // 50 ms; -> 20 refreshu za sekundu
		Draw();
		if (ProcessKeys()) break;
		while (tmr != 0); // cekame, za dobehe timer
	}
	Destroy();
}

bool GMenuSet::LoadGfx()
{
	Destroy();
	if (!(m_back = hload_bitmap("gfx\\menu\\menuset.jpg"))) return false;
	return true;
}

void GMenuSet::Destroy()
{	
	if (m_back != NULL) destroy_bitmap(m_back);
}

bool GMenuSet::ProcessKeys()
{
	int  c, c2;

	while(keypressed()) {
		c2 = readkey();
		c = (c2 >> 8);

		switch (c) {
		case KEY_UP : 
			if(--m_item < 0) m_item = it_zpet;
			break;
		case KEY_DOWN :
			if(++m_item > it_zpet) m_item = 0;
			break;
		case KEY_LEFT :
			if (m_item == it_postava) 
				if(--m_run->m_sold[0].m_ID < 0) m_run->m_sold[0].m_ID = MAX_SOLDIERS-1;
			if (m_item == it_mapa) 
				if(--m_run->m_mapa < 1) m_run->m_mapa = 1;
			if (m_item == it_svetlo) 
				m_run->m_svetlo = GFX_LOADED_NORMAL;
			break;
		case KEY_RIGHT :
			if (m_item == it_jmeno) 
				if(++m_run->m_sold[0].m_ID > MAX_SOLDIERS) m_run->m_sold[0].m_ID = 0;
			if (m_item == it_mapa) 
				if(++m_run->m_mapa > m_run->m_maps) m_run->m_mapa = m_run->m_maps;
			if (m_item == it_svetlo) 
				m_run->m_svetlo = GFX_LOADED_DARK;
			break;
		case KEY_ENTER :

			if (m_item == it_zpet) return true;
			break;
		case KEY_BACKSPACE :
		case KEY_DEL :
			if (m_run->m_sold[0].m_name[0] != '\0')
				m_run->m_sold[0].m_name[strlen(m_run->m_sold[0].m_name)-1] = '\0';
			break;
		default :
			c = c2 & 0xff;
			if (islower(c)) c = _toupper(c); // aby se nepsalo malejma pismenkama
			int len = strlen(	m_run->m_sold[0].m_name);
			if (len < 50) {
				m_run->m_sold[0].m_name[len] = c;
				m_run->m_sold[0].m_name[len+1] = '\0';
			}
		}
	}

	return false;
}

void GMenuSet::Draw()
{
	hscreen.AcquireBack();
	draw_sprite(hscreen.m_back, m_back, 0, 0);

	// menu
	if(++m_angle > 255) m_angle  = 0;
		rotate_sprite(hscreen.m_back, b_solds[Sparams[m_run->m_sold[0].m_ID].bindex], 300, 70, itofix(m_angle));

	textprintf_centre(hscreen.m_back, font, 320, 130, Col(0), "Jmeno : %s ", m_run->m_sold[0].m_name);
	textprintf_centre(hscreen.m_back, font, 320, 160, Col(1), "<- Postava ->");
	textprintf_centre(hscreen.m_back, font, 320, 190, Col(2), "<- Mapa :  %d ->", m_run->m_mapa);
	if (m_run->m_svetlo == GFX_LOADED_NORMAL)
		textprintf_centre(hscreen.m_back, font, 320, 220, Col(3), "<- Svetlo :  den ->");
	else
		textprintf_centre(hscreen.m_back, font, 320, 220, Col(3), "<- Svetlo :  noc ->");

	textprintf_centre(hscreen.m_back, font, 320, 250, Col(4), "Zpet");

	// okoli
	textprintf_centre(hscreen.m_back, font, 320,  50, makecol(255,10,10), "Nastaveni");
	hscreen.ReleaseBack();

	hscreen.Flip();
}

int GMenuSet::Col(int index)
{
	if (index == m_item) return makecol(255,255,255);
	return makecol(128,128,128);
}
