// GObject.cpp: implementation of the GObject class.
//
//////////////////////////////////////////////////////////////////////

#include "stdh.h"
#include "GObject.h"
#include "GSoldier.h"
#include "objects.h"

/*////////////////////////////////////////////////////////////////////////////////
  Nulovaci konstruktor
*/
GObject::GObject()
{
	m_par.bindex = -1;
	m_par.h2  = -1;
	m_par.w2  = -1;
	m_smashed = false;
	m_x = 0;
	m_y = 0;
	m_btmp = NULL;
}

/*////////////////////////////////////////////////////////////////////////////////
  Prazdny destruktor
*/
GObject::~GObject()
{
}

/*////////////////////////////////////////////////////////////////////////////////
  Kresli auta na danou bitmapu ( zavodni plochu )
  dest - pointer na bitmapu, kam se ma auto nakreslit (velikosti DF_X, DF_X )
  x,y  - souradnice stredu dest vuci trati ( jinak jsou ve stredu obrazovky )
  hi   - kreslena haldina
*/
void GObject::Draw(BITMAP *dest, int x, int y, int hi, bool shadow)
{

}

/*////////////////////////////////////////////////////////////////////////////////
  Inicializuje objekt
  x,y  : souradnice seho umisteni v bitmape
  ID   : index v poli Oparams
*/
void GObject::Init(int x, int y, int ID)
{
	m_x = x;
	m_y = y;

	m_dx = 600;
	m_dy = 200;

	m_krev = 0;
	
	m_smashed = false;
	m_par = Oparams[ID];
	m_ID  = ID;

	m_angle = 0;
	m_ralpha = 0;

	LoadGFX();
	m_tmpa = m_angle + 1;
	UpdateTmp();

	ComputeRect();
}

/*////////////////////////////////////////////////////////////////////////////////
  Hybne objektem (je-li type letajici)
*/
void GObject::Move()
{

}

/*////////////////////////////////////////////////////////////////////////////////
	Vypocita hranicni obdelniky
*/
void GObject::ComputeRect()
{
	m_rect[0].x = m_x + m_par.w2;
	m_rect[0].y = m_y - m_par.h2;

	m_rect[1].x = m_x - m_par.w2;
	m_rect[1].y = m_y - m_par.h2;

	m_rect[2].x = m_x - m_par.w2;
	m_rect[2].y = m_y + m_par.h2;

	m_rect[3].x = m_x + m_par.w2;
	m_rect[3].y = m_y + m_par.h2;

	m_srect.bottom = m_y + m_par.h2;
	m_srect.top    = m_y - m_par.h2;
	m_srect.left   = m_x - m_par.w2;
	m_srect.right  = m_x + m_par.w2;
}


/*////////////////////////////////////////////////////////////////////////////////
  Zaktualizuje stin
*/
void GObject::UpdateTmp()
{
	if (m_btmp == NULL) return;
	if (m_angle == m_tmpa) return;

	clear_to_color(m_btmp, makecol(255, 0, 255)); // ruzova je barva nase :)
	rotate_sprite(m_btmp, b_sobjects[m_ID], m_tmpx/2-m_par.wb2, m_tmpx/2-m_par.hb2, itofix(m_angle));
//	draw_sprite(m_btmp, b_sobjects[m_ID], m_tmpx/2-m_par.wb2, m_tmpx/2-m_par.hb2);
	m_tmpa = m_angle;
}

/*////////////////////////////////////////////////////////////////////////////////
  Znici vsechny bitmapy
*/
void GObject::Destroy()
{
	if (m_btmp != NULL) 
		destroy_bitmap(m_btmp);
	m_btmp = NULL;
}

/*////////////////////////////////////////////////////////////////////////////////
  Vytvori bitmapu stinu
*/
void GObject::LoadGFX()
{
	Destroy();
}
