// GSoldier.h: interface for the GSoldier class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _G_SOLDIER_INCLUDE_
#define _G_SOLDIER_INCLUDE_

// includy
#include "GClasses.h"
#include "soldiers.h"
#include "GAI.h"
#include "zbrane.h"

// vlastni trida zapouzdrujici auta
class GSoldier  
{
public:
	void CompMove(GRun *run, int ID);
	bool HitBy(int demage, int who);
  // aktualni nastaveni auta
   int    m_angle;     // uhel natoceni ( 0 == doprava vodorovne, dokola je 256 )
	double m_angleRad;  // uhel v radianech

	double m_x, m_y; // pozice
	double m_speed;  // rychlost
	int    m_health;  // zdravi;
	int    m_shield;  // stit
	int    m_frags;


	// animace zasahu
	int    m_a_shield;
	int    m_a_krev;
	int    m_a_nohy;
	int    m_a_zbran;   // animace zbrane

	int    m_a_water;   // animace vody


	int    m_dist; // polomer vojaka (pro zasah)
	int    m_zbran;
	int    m_tochange;

	int    m_nshield; // pro dorustani stitu
	int    m_nrtf;    // redy to fire

	int    m_sx, m_sy;  // rozmer mapy

	bool   m_active; // zda je vojak aktivni ( kdyz neni, tak ani nezavodi )


  // pozadavky ridice
	bool  m_fwd;    // jizda vpred
	bool  m_back;   // jizda vzad (brzda)
	bool  m_left;   // zataceni vlevo
	bool  m_right;  // zataceni vpravo
	bool  m_side;   // chodi vlevo, vpravo
	bool  m_run;    // beha
	bool  m_shoot;  // strili
	bool  m_chzbran; // chce zmenit zbran
	bool  m_liveup;  // chce vstat z mrtvych


	// AI
	int   m_AI_l;   // uroven AI
	GAI   m_AI;

	int   m_lastkill;   // posledni zabity
	int   m_lastkilled; // poslednim zabytym
	int   m_lasthit;    // poslednim zasahly


	// vybaveni
	int   m_naboje[MAX_STREL];
	int   m_narust[MAX_STREL];
	bool  m_zbrane[MAX_ZBRANE];

	bool  m_dorustani;

  // init & nastavovaci fce 
	GSoldier();
	virtual ~GSoldier();
	void Init(int index, int x, int y, int zbran, bool dorust, int vybaven, GMap *map);
	void SetKeys(bool fwd, bool back, bool left, bool right, bool side, bool run, bool shoot, bool chzbran, bool liveup);

  // graficke fce 
	bool LoadGFX();
	void Destroy();
	void Draw(BITMAP *dest, int x, int y);
	void RaiseFromDead(GMap *map, int vybaven);

	char m_name[50]; // jmeno hrace (vojaka)

	int m_ID; // ID v m_par
	int m_index;  // index v poli u GRun

  // pohybove fce 
	void Move(GRun *run);

  // fce pro narazy ( tech je )
   RECT   m_rect;  // vrcholy rotvane bitmapy auta (a s otocenim)
};

#endif // #ifndef _G_SOLDIER_INCLUDE_
