#ifndef _OBJECTS_PARAMS_INCLUDE_
#define _OBJECTS_PARAMS_INCLUDE_


#define MAX_OBJECTS             23 // maximalni pocet objektu
#define MAX_OBJECTS_BITMAPS    100 // pocet bitmap u objektu 

extern BITMAP* b_objects[MAX_OBJECTS_BITMAPS];  // bitmapy k objektum
extern BITMAP* b_sobjects[MAX_OBJECTS];         // stiny

#define KREV_X 13  // polovicni rozmer bitmapi krve
#define KREV_Y 13

typedef struct {
	char   name[30]; // jemno objektu

	char   sname[4];  // zkracene jemno (3pismena a 0)

  // technicke udaje
	int    type; // typ objektu

  // graficke udaje
	int    bindex;  // index bitmapy;
	int    stin;    // odsazeni stinu
	int    large;   // zda se ma pri modu large kreslit primo do podkladu


	int    wb2;     // sirka bitmapy /2
	int    hb2;     // vyska bitmapy /2

// rozmery na narazeni
	int    w2;      // sirka/2
	int    h2;      // vyska/2

	int dangle;  // lze -li objektu dat pocatecni natoceni (1/0)
	int angles;  // zda objekt muze rotovat (1/0)

	int turning;  // schopnost zatacet (1/0)
	int speed;    // moznost pohybu (1/0)

	char   file[30]; // 1.cast nazvu souboru

} st_GObjects_params;

const st_GObjects_params Oparams[MAX_OBJECTS] = {
// Staticke objekty
//    TYP                       ROZMERY      PARAMETRY NATOCENI
//  Dum
	{"Barak","DUM", 0,  0,3,1,  70, 70, 50, 50,   0, 0, 0, 0,  "ODum1"},

 // Lidi 
	{"Clovek 1",   "ClK",   0,  10,3,0,   15, 25, 10, 10,   1, 1, 0, 0,  "OClov1"},
	{"Clovek 2",   "CLK",   0,  12,3,0,   15, 25, 10, 10,   1, 1, 0, 0,  "OClov2"},
	{"Clovek 3",   "CLK",   0,  14,3,0,   15, 25, 10, 10,   1, 1, 0, 0,  "OClov3"},

// Stromy
	{"Strom 1","STR",  0,    30,4,0,   45, 43, 10, 10,  1, 0, 0, 0,  "OTree1"},
	{"Strom 2","STR",  0,    31,4,0,   43, 45, 10, 10,  1, 0, 0, 0,  "OTree2"},
	{"Strom 3","STR",  0,    32,4,0,   42, 45, 10, 10,  1, 0, 0, 0,  "OTree3"},
	{"Strom 4","STR",  0,    33,4,0,   29, 26, 10, 10,  1, 0, 0, 0,  "OTree4"},

// Velke Stromy
	{"Strom vleky 1","STR",  0,    40,8,0,   74, 65, 20, 20,  1, 0, 0, 0,  "OTreeB1"},
	{"Strom vleky 2","STR",  0,    41,8,0,   68, 62, 20, 20,  1, 0, 0, 0,  "OTreeB2"},
	{"Strom vleky 3","STR",  0,    42,8,0,   62, 60, 20, 20,  1, 0, 0, 0,  "OTreeB3"},

// Pole 
 	{"Pole male" ,"POL",  0,    50,0,1,   172, 95, 0, 0,  0, 0, 0, 0,  "OPole1"},
 	{"Pole velke","POL",  0,    51,0,1,  221, 95, 0, 0,  0, 0, 0, 0,  "OPole2"},

// Kravy
	{"Krava bila",  "KRV",   0,    52,4,0,   18, 15, 13, 13,   1, 1, 0, 0,  "OKrava1"},
	{"Krava hneda", "KRV",   0,    54,4,0,   18, 15, 13, 13,   1, 1, 0, 0,  "OKrava2"},

// Zemedleci
	{"Pitko krav",  "PIT",   0,  56,3,1,   17,  6, 17,  6,   0, 0, 0, 0,  "OPitko"},
	{"Hromada sena","SEN",   0,  57,3,1,   24, 23, 23, 23,   1, 0, 0, 0,  "OSlama1"},
	{"Hrabe",       "HRB",   0,     58,0,1,   13, 13,  0,  0,   1, 0, 0, 0,  "OHrabe"},

// Les
	{"Klady", "KLD",  0,    60,3,1,    23, 50, 23, 50,  0, 0, 0, 0,  "OKlady"},
	{"Kameny","KAM",  0,       61,0,1,    37, 26,  0,  0,  1, 0, 0, 0,  "OKameny"},
	{"Parez" ,"PAR",  0,    62,3,1,    10, 12, 10, 12,  1, 0, 0, 0,  "OParez"},

// Zed
	{"Zed H",  "ZED",  0,    70,3,1,    15,  5, 15,  5,  0, 0, 0, 0,  "OZed_H"},
	{"Zed V",  "ZED",  0,    71,3,1,     5, 15,  5, 15,  0, 0, 0, 0,  "OZed_V"},

// Flying objekty

};



#endif // #ifndef _OBJECTS_PARAMS_INCLUDE_