#ifndef _ZBRANE_PARAMS_INCLUDE_
#define _ZBRANE_PARAMS_INCLUDE_

#define MAX_ZBRANE     6  // pocet zbraani
#define MAX_STREL      8  // pocet druhu streliva
#define MAX_POWERUPS   8
#define MAX_ZBRAN_ANIM 6

extern BITMAP*  b_strel[MAX_STREL];				// obrazky strel
extern BITMAP*  b_zbraneB[MAX_ZBRANE];				// velke obrazky zbrani
extern BITMAP*  b_zbrane[MAX_ZBRANE][MAX_ZBRAN_ANIM];				// male obrazky zbrani
extern BITMAP*  b_powerups[MAX_POWERUPS];			// obrazky bonusu


typedef struct {
	char name[15]; //jmeno pusky
	int  rate;  // rychlost strelby
	int  strelaID; // typ streliva
	int  angle;  // uhlovy rozptyl
	int  dx,dy;  // posun zacatku strelby (aby se strilelo opravdu z hlavne)
	int  anim;   // pocet animaci zbrane
	bool so;     // poze pri strelbe
} st_Zbrane_params;

typedef struct {
	char    name[15];  // nazev
	double  speed;  // rychlost
	int     demage;  // schopnost nicit
	int     dist;  // dolet
   int     rng;   // velikost vybuchu
	int     attime; // strel najednou
	int	  strel;  // max pocet strel (u vojaka)
	int     raise;  // rychlost dorustani naboju
	int     explosive;  // zda vybuchuje ( do kolika buchu )
	bool    target;  // automireni
	int     eID;     // id explozni strely
} st_GStela_params;

typedef struct {
	char   name[20];  // nazev
	int    health;    // pocet zivotu, ktere pridava
	int    shields;   // kolik pridava stitu
	int    nID;       // ID naboju, ktere pridava
	int    cnt;       // kolik jich pridava
} st_powerups;


const st_Zbrane_params  Zparams[MAX_ZBRANE] = {
	{ "Kulomet",      1,  0,   10, 22, 8, 4, true},
	{ "Mrazic",       3,  1,    1, 23, 0, 4, false},
	{ "Granatomet",   4,  2,    1, 20, 0, 1, true},
	{ "Plamenomet",   1,  4,    6, 30, 0, 3, false},
	{ "Plazmomet",    3,  5,    1, 23, 0, 4, false},
	{ "Brok",        10,  7,   25, 22, 0, 1, false},
};

const st_GStela_params  Nparams[MAX_STREL] = {
	{ "Kulky",        38,  35, 600,  0,  2, 150, 10,   0, false},
	{ "Led",          31,  70, 500,  0,  1, 100, 20,   0, false},
	{ "Granat",       22,   0, 200, 50,  1,  30, 50,  20, false},
	{ "Granat buch",   3,  10,  30,  0,  1,   0,  0,   0, false},
	{ "Plamen",       10, 100, 200,  0,  1, 130, 45,   0, false},
	{ "Plazma",       29,  50, 250, 20,  1,  80, 30,  20, false},
	{ "Plazma bum",    3,  15,  20,  0,  1,   0,  0,   0, false},
	{ "Brok",         40,  50, 300,  0, 20,  30, 30,   0, false},
};

const st_powerups Pparams[MAX_POWERUPS] = {
	{ "lekarnu",       100,   0, 0,   0},
	{ "baterku",         0, 100, 0,   0},
	{ "zasobnik",        0,   0, 0,  50},
	{ "freony",          0,   0, 1,  20},
	{ "granaty",         0,   0, 2,  10},
	{ "kanistr benzinu", 0,   0, 4,  40},
	{ "plazma kyselinu", 0,   0, 5,  20},
	{ "chutny brok",     0,   0, 7,  10},
};

#endif
